//+------------------------------------------------------------------+
//|                                                OILFXMACDv005.mq4 |
//| Original idea by OILFXPRO                                        |
//| Original code from metaquotes                                    |
//| Modify and improve codings by davidke20                          |
//| v0.002 added close all orders on friday function - davidke20     |
//| v0.003 auto detect trigger price for JPY pairs - davidke20       |
//| v0.004 MACD comment on chart for debug purpose - davidke20       |
//| v0.005 Revised to make 1 trade at 1 signal & added trading time  |
//|        filter                                                    |
//|                        Copyright  2007, http://www.forex-tsd.com|
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, FOREX-TSD"
#property link      "http://www.forex-tsd.com/expert-advisors-metatrader-4/11482-oilfxpro-trendmaster-double-macd-ea-freeversion.html#post174184"

extern int     Magic_number   =  772188;
extern int     Take_Profit    =  40;
extern int     Stop_Loss      =  40;
extern int     TrailingStop   =  10;
extern double  Lots           =  0.1;
extern int     Gap            =  20;
extern int     Slippage       =  3;
extern int     Duration       =  3600;
extern string  MACD_Setup;
extern int     Fast_EMA1      =  12;
extern int     Slow_EMA1      =  18;
extern int     Signal1        =  15;
extern double  Trigger1       =  7;
extern int     Fast_EMA2      =  40;
extern int     Slow_EMA2      =  104;
extern int     Signal2        =  36;
extern double  Trigger2       =  0;
extern bool    CloseNReverse  =  false;
extern bool    FridaySafe     =  false;
extern string  Close_all_trades_at_this_time;
extern int     Hours          =  15;
extern int     Minutes        =  00;
extern bool    TimeFilter        = true;
extern int     TradingHourStart  = 5;
extern int     TradingHourStop   = 12;

int KillDuration=0,i=0;
datetime TimeStamp=0;
bool Buy=false,Sell=false;
string EA_name="OILFXMACD";
double TakeProfit,StopLoss;
double OpenOrderPrice;
string text2;

//+------------------------------------------------------------------+
//| Initialize                                                       |
//+------------------------------------------------------------------+
int init()
{
   if(FridaySafe)
   {
      if(Hours>23)
      {FridaySafe=false;}
      if(Minutes>59)
      {Minutes=00;}
   }
   Trigger1=Trigger1*Point;
   Trigger2=Trigger2*Point;
   if(TradingHourStart<TradingHourStop)
   {TimeFilter=false;}
}

//+------------------------------------------------------------------+
//| Orders management function                                       |
//+------------------------------------------------------------------+
bool isNewSymbol(string current_symbol)
  {
   //loop through all the opened order and compare the symbols
   int total  = OrdersTotal();
   for(int cnt = 0 ; cnt < total ; cnt++)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      string selected_symbol = OrderSymbol();
      if (current_symbol == selected_symbol && OrderMagicNumber()==Magic_number)
      return (False);
    }
    return (True);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int cnt, ticket, total;

   double MACD1=iMACD(NULL,0,Fast_EMA1,Slow_EMA1,Signal1,PRICE_CLOSE,MODE_MAIN,0);
   double MACD2=iMACD(NULL,0,Fast_EMA2,Slow_EMA2,Signal2,PRICE_CLOSE,MODE_MAIN,0);
   
   if(MACD1>Trigger1 && MACD2>Trigger2)
   {Buy=true;Sell=false;}
   else
   {  if(MACD1<Trigger1-(Trigger1*2) && MACD2<Trigger2-(Trigger2*2))
      {Buy=false;Sell=true;}
      else
      {Buy=false;Sell=false;}
   }

   if(TimeFilter && Buy==false && Sell==false)
   {
      if(Hour()<TradingHourStop && !(Hour()>=TradingHourStart))
      {
         Comment("No trading hour!!!");
         return(0);
      }
   }

   Comment(
      "\nMACD Trigger 1st level:",Trigger1,
      "\nCurrent MACD 1st level:",DoubleToStr(MACD1,Digits+1),
      "\nMACD Trigger 2nd level:",Trigger2,
      "\nCurrent MACD 2nd level:",DoubleToStr(MACD2,Digits+1),
      "\n",
      "\n",text2);

   total=OrdersTotal();
   if(total < 1 || isNewSymbol(Symbol()) && TimeStamp!=iTime(NULL,0,0)) 
     {
      // no opened orders identified
      if(AccountFreeMargin()<(1000*Lots))
        {
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);  
        }
      if(Duration>0)
      {KillDuration=TimeCurrent()+Duration;}
      else
      {KillDuration=0;}
      // check for long position (BUY) possibility
      if(Buy && !Sell)
        {
            OpenOrderPrice=Ask+Gap*Point;
            if(Stop_Loss>5)
               {StopLoss=OpenOrderPrice-Stop_Loss*Point;}
               else
               {StopLoss=0;}
            if(Take_Profit>5)
               {TakeProfit=OpenOrderPrice+Take_Profit*Point;}
               else
               {TakeProfit=0;}
            ticket=OrderSend(Symbol(),OP_BUYSTOP,Lots,OpenOrderPrice,Slippage,StopLoss,TakeProfit,EA_name,Magic_number,KillDuration,Blue);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) TimeStamp=iTime(NULL,0,0);
           }
         else Print("Error opening BUY order : ",GetLastError()); 
         return(0); 
        }
      // check for short position (SELL) possibility
      if(Sell && !Buy)
        {
            OpenOrderPrice=Bid-Gap*Point;
            if(Stop_Loss>5)
               {StopLoss=OpenOrderPrice+Stop_Loss*Point;}
               else
               {StopLoss=0;}
            if(Take_Profit>5)
               {TakeProfit=OpenOrderPrice-Take_Profit*Point;}
               else
               {TakeProfit=0;}
            ticket=OrderSend(Symbol(),OP_SELLSTOP,Lots,OpenOrderPrice,Slippage,StopLoss,TakeProfit,EA_name,Magic_number,KillDuration,Red);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) TimeStamp=iTime(NULL,0,0);
           }
         else Print("Error opening SELL order : ",GetLastError()); 
         return(0); 
        }
      return(0);
     }
   // it is important to enter the market correctly, 
   // but it is more important to exit it correctly...   
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol() &&  // check for symbol
         OrderMagicNumber()==Magic_number)
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            // should it be closed?
            if(Sell && !Buy && CloseNReverse)
                {
                 OrderClose(OrderTicket(),OrderLots(),Bid,3,Blue); // close position
                 return(0); // exit
                }
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Yellow);
                     return(0);
                    }
                 }
              }
           }
         else // go to short position
           {
            // should it be closed?
            if(Buy && !Sell && CloseNReverse)
              {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Red); // close position
               return(0); // exit
              }
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Yellow);
                     return(0);
                    }
                 }
              }
           }
        }
     }

   if(FridaySafe)
   {
      text2="All OILFXMACD trades will be close on Friday''s "+Hours+":"+Minutes;
      if (Day()==5 && Hour()>Hours && Minute()>Minutes)
      {
      for(i=OrdersTotal()-1;i>=0;i--)
      {
         OrderSelect(i, SELECT_BY_POS);
         if((OrderSymbol()==Symbol()) && OrderMagicNumber()==Magic_number)
         {
               int type   = OrderType();
                  
               bool result = false;
               int    obj_total=ObjectsTotal();
   
               for(int i=0;i<obj_total;i++)
               {
                  ObjectsDeleteAll();
               }              
               switch(type)
               {
               //Close opened long positions
               case OP_BUY  : result = OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),Slippage,Pink);
                              break;
                 
               //Close opened short positions
               case OP_SELL : result = OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),Slippage,Pink);
                              break;
               //Close pending orders
               case OP_BUYLIMIT  : result = OrderDelete( OrderTicket() );  break;
               case OP_BUYSTOP   : result = OrderDelete( OrderTicket() );  break;
               case OP_SELLLIMIT : result = OrderDelete( OrderTicket() );  break;
               case OP_SELLSTOP  : result = OrderDelete( OrderTicket() );  break;
               }
             
               if(result == false)
               {
                  Print("Error closing orders! Error code: ",GetLastError());
               }
           }
      }
      return(0);
      }
   }
   return(0);
  }
// the end.